export namespace model {
	
	export class SubThing {
	    ID: number;
	    ThingID: number;
	    Name: string;
	
	    static createFrom(source: any = {}) {
	        return new SubThing(source);
	    }
	
	    constructor(source: any = {}) {
	        if ('string' === typeof source) source = JSON.parse(source);
	        this.ID = source["ID"];
	        this.ThingID = source["ThingID"];
	        this.Name = source["Name"];
	    }
	}
	export class Thing {
	    ID: number;
	    Name: string;
	    Subthings: SubThing[];
	
	    static createFrom(source: any = {}) {
	        return new Thing(source);
	    }
	
	    constructor(source: any = {}) {
	        if ('string' === typeof source) source = JSON.parse(source);
	        this.ID = source["ID"];
	        this.Name = source["Name"];
	        this.Subthings = this.convertValues(source["Subthings"], SubThing);
	    }
	
		convertValues(a: any, classs: any, asMap: boolean = false): any {
		    if (!a) {
		        return a;
		    }
		    if (a.slice && a.map) {
		        return (a as any[]).map(elem => this.convertValues(elem, classs));
		    } else if ("object" === typeof a) {
		        if (asMap) {
		            for (const key of Object.keys(a)) {
		                a[key] = new classs(a[key]);
		            }
		            return a;
		        }
		        return new classs(a);
		    }
		    return a;
		}
	}

}

